PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Protected Member Functions | Static Protected Member Functions | List of all members
PPOP3 Class Reference

A TCP/IP socket for the Post Office Protocol version 3. More...

`#include <inetmail.h>`

Inheritance diagram for PPOP3:
[legend]
Collaboration diagram for PPOP3:
[legend]

## Public Types
enum | Commands { USER, PASS, QUIT, RSET, NOOP, STATcmd, LIST, RETR, DELE, APOP, TOP, UIDL, AUTH, NumCommands }

## Protected Member Functions
| PPOP3 ()
virtual PINDEX | ParseResponse (const PString &line)
| Parse a response line string into a response code and any extra info on the line. More...
Protected Member Functions inherited from PInternetProtocol
| PInternetProtocol (const char *defaultServiceName, PINDEX cmdCount, char const *const *cmdNames)
Protected Member Functions inherited from PIndirectChannel
virtual PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
P_INT_PTR | GetOSHandleAsInt () const
int | PXClose ()
| PChannel ()
| Create the channel. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Static Protected Member Functions
static const PString & | okResponse ()
static const PString & | errResponse ()

## Additional Inherited Members
Public Member Functions inherited from PInternetProtocol
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
void | SetReadLineTimeout (const PTimeInterval &t)
| Set the maximum timeout between characters within a line. More...
virtual PBoolean | Connect (const PString &address, WORD port=0)
| Connect a socket to a remote host for the internet protocol. More...
virtual PBoolean | Connect (const PString &address, const PString &service)
virtual PBoolean | Accept (PSocket &listener)
| Accept a server socket to a remote host for the internet protocol. More...
const PString & | GetDefaultService () const
| Get the default service name or port number to use in socket connections. More...
PIPSocket * | GetSocket () const
| Get the eventual socket for the series of indirect channels that may be between the current protocol and the actual I/O channel. More...
virtual PBoolean | WriteLine (const PString &line)
| Write a string to the socket channel followed by a CR/LF pair. More...
virtual PBoolean | ReadLine (PString &line, PBoolean allowContinuation=false)
| Read a string from the socket channel up to a CR/LF pair. More...
virtual void | UnRead (int ch)
| Put back the characters into the data stream so that the next Read() function call will return them first. More...
virtual void | UnRead (const PString &str)
virtual void | UnRead (const void *buffer, PINDEX len)
virtual bool | WriteCommand (PINDEX cmdNumber, const PString &param=PString::Empty())
| Write a single line for a command. More...
virtual bool | WriteCommand (PINDEX cmdNumber, const PString &param, const PMIMEInfo &mime)
virtual PBoolean | ReadCommand (PINDEX &num, PString &args)
| Read a single line of a command which ends with a CR/LF pair. More...
virtual PBoolean | ReadCommand (PINDEX &num, PString &args, PMIMEInfo &mime)
virtual PBoolean | WriteResponse (unsigned numericCode, const PString &info)
| Write a response code followed by a text string describing the response to a command. More...
virtual PBoolean | WriteResponse (const PString &code, const PString &info)
virtual PBoolean | ReadResponse ()
| Read a response code followed by a text string describing the response to a command. More...
virtual PBoolean | ReadResponse (int &code, PString &info)
virtual PBoolean | ReadResponse (int &code, PString &info, PMIMEInfo &mime)
virtual int | ExecuteCommand (PINDEX cmdNumber)
| Write a command to the socket, using `WriteCommand()` and await a response using `ReadResponse()`. More...
virtual int | ExecuteCommand (PINDEX cmdNumber, const PString &param)
int | GetLastResponseCode () const
| Return the code associated with the last response received by the socket. More...
PString | GetLastResponseInfo () const
| Return the last response received by the socket. More...
Static Public Member Functions inherited from PChannel
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
static PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Types inherited from PInternetProtocol
enum | StuffState { DontStuff, StuffIdle, StuffCR, StuffCRLF, StuffCRLFdot, StuffCRLFdotCR }
Protected Attributes inherited from PInternetProtocol
PString | defaultServiceName
PStringArray | commandNames
PCharArray | unReadBuffer
PINDEX | unReadCount
PTimeInterval | readLineTimeout
enum PInternetProtocol::StuffState | stuffingState
PBoolean | newLineToCRLF
int | lastResponseCode
PString | lastResponseInfo
Friends inherited from PObject

## Detailed Description

A TCP/IP socket for the Post Office Protocol version 3.

When acting as a client, the procedure is to make the connection to a remote server, then to retrieve a message using the following procedure: `PPOP3Client mail("popserver"); if (mail.IsOpen()) { if (mail.LogIn("Me", "password")) { if (mail.GetMessageCount() > 0) { PUnsignedArray sizes = mail.GetMessageSizes(); for (PINDEX i = 0; i < sizes.GetSize(); i++) { if (mail.BeginMessage(i+1)) mail.Read(myMessage, sizes[i]); else PError << "Error getting mail message." << endl; } } else PError << "No mail messages." << endl; } else PError << "Mail log in failed." << endl; } else PError << "Mail conection failed." << endl;`

When acting as a server, a descendant class would be created to override at least the HandleOpenMailbox(), HandleSendMessage() and HandleDeleteMessage() functions. Other functions may be overridden for further enhancement to the sockets capabilities, but these will give a basic POP3 server functionality.

The server socket thread would continuously call the ProcessMessage() function until it returns false. This will then call the appropriate virtual function on parsing the POP3 protocol.

## Member Enumeration Documentation

enum PPOP3::Commands

Enumerator
USER |
PASS |
QUIT |
RSET |
NOOP |
STATcmd |
LIST |
RETR |
DELE |
APOP |
TOP |
UIDL |
AUTH |
NumCommands |

## Constructor & Destructor Documentation

PPOP3::PPOP3 | ( |  | ) |
| protected

## Member Function Documentation

static const PString& PPOP3::errResponse | ( |  | ) |
| static protected

static const PString& PPOP3::okResponse | ( |  | ) |
| static protected

virtual PINDEX PPOP3::ParseResponse | ( | const PString & | line | ) |
| protected virtual

Parse a response line string into a response code and any extra info on the line.

Results are placed into the member variables `lastResponseCode` and `lastResponseInfo`.

The default bahaviour looks for a space or a '-' and splits the code and info either side of that character, then returns false.

Returns
  Position of continuation character in response, 0 if no continuation lines are possible.

Parameters

  line | Input response line to be parsed

Reimplemented from PInternetProtocol.

The documentation for this class was generated from the following file:

- inetmail.h